# NOTE: Derived from auto/Bforum.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Bforum;

#line 2141 "auto/Bforum.pm (autosplit into auto\Bforum\check.al)"
sub check {

	my ($tmp1,$tmp2);

	&_path($SET{'USER_DIR'});

	$check{'Address'} = "OK";
	$check{'status'}{'Address'} = $SET{'ADDRESS'};
	if ($SET{'ADDRESS'} !~ /^.+\@.+\..+$/) {
		$check{'Address'} = "NG";
	}

	$check{'User directory'} = "OK";
	$check{'status'}{'User directory'} = "$SET{'USER_DIR'}/";
	if (!-d $SET{'USER_DIR'}) {
		$check{'User directory'} = "NG";
		$check{'status'}{'User directory'} = "Not found:<b>$SET{'USER_DIR'}/</b>";
	} elsif (!-r $SET{'USER_DIR'} || !-w $SET{'USER_DIR'} || !-x $SET{'USER_DIR'}) {
		$check{'User directory'} = "NG";
		$check{'status'}{'User durectory'} = "Permission denied:<b>$SET{'USER_DIR'}/</b>";
	}

	if ($in{'id'} ne 'Check') {
		$check{'Data directory'} = "OK";
		$check{'status'}{'Data directory'} = "$SET{'USER_DIR'}/$in{'id'}/";
		if (!-d "$SET{'USER_DIR'}/$in{'id'}") {
			$check{'Data directory'} = "NG";
			$check{'status'}{'Data directory'} = "Not found:<b>$SET{'USER_DIR'}/$in{'id'}</b>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}" || !-w "$SET{'USER_DIR'}/$in{'id'}" || !-x "$SET{'USER_DIR'}/$in{'id'}") {
			$check{'Data directory'} = "NG";
			$check{'status'}{'Data directory'} = "Permission denied:<b>$SET{'USER_DIR'}/$in{'id'}</b>";
		}
		$check{'Index file'} = "OK";
		$check{'status'}{'Index file'} = "$SET{'USER_DIR'}/$in{'id'}/index";
		if (!-d "$SET{'USER_DIR'}/$in{'id'}") {
			$check{'Index file'} = "NG";
			$check{'status'}{'Index file'} = "Not found:<b>$SET{'USER_DIR'}/$in{'id'}/index</b>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}/index" || !-w "$SET{'USER_DIR'}/$in{'id'}/index") {
			$check{'Index file'} = "NG";
			$check{'status'}{'Index file'} = "Permission denied:<b>$SET{'USER_DIR'}/$in{'id'}/index</b>";
		} else {
		}
	}

	$check{'Sendmail'} = "OK";
	($tmp1,undef) = split(/\s/,$SET{'SENDMAIL'});
	$check{'status'}{'Sendmail'} = $SET{'SENDMAIL'};
	if (!-e $tmp1) {
		$check{'Sendmail'} = "NG";
		$check{'status'}{'Sendmail'} = "Not found:<b>$tmp1</b>";
	} elsif (!-x $tmp1 && !-r $tmp1) {
		$check{'Sendmail'} = "NG";
		$check{'status'}{'Sendmail'} = "Permission denied:<b>$tmp1</b>";
	}

	foreach ({item => "Do sendmail",set => "SENDMAIL_DO"},{item => "Do portal",set => "PORTAL_DO"},{item => "Do check",set => "CHECK_DO"},{item => "Do archive",set => "ARCHIVE_DO"},{item => "Do compress",set => "COMPRESS_DO"}) {
		$check{$$_{'item'}} = "Yes";
		$check{'status'}{$$_{'item'}} = "Value OK";
		if ($SET{$$_{'set'}} eq 'N') {
			$check{$$_{'item'}} = "No";
		} elsif ($SET{$$_{'set'}} ne 'Y') {
			$check{'status'}{$$_{'item'}} = "Illegal value:<b>$SET{$$_{'set'}}</b>";
		}
	}

	$check{'User Name'} = "OK";
	$check{'status'}{'User Name'} = getlogin;

	foreach ("BF.about","BF.browser","BF.confirm","BF.delete","BF.email","BF.email.error","BF.error","BF.foot","BF.form","BF.head","BF.index","BF.index.foot","BF.index.head","BF.list","BF.list.foot","BF.list.head","BF.notice","BF.portal","BF.thread","BF.thread.foot","BF.thread.head","BF.tree","BF.tree.foot","BF.tree.head","BF.view") {
		$check{$_} = "OK";
		if (!-f "$SET{'USER_DIR'}/$in{'id'}/$_" && !-f "$SET{'USER_DIR'}/$_" && !-f "$SET{'USER_DIR'}/$in{'id'}/BF.bfa" && !-f "$SET{'USER_DIR'}/BF.bfa") {
			$check{$_} = "NG";
			$check{'status'}{$_} = "Not found<b>$_</b>";
		} elsif (!-r "$SET{'USER_DIR'}/$in{'id'}/$_" && !-r "$SET{'USER_DIR'}/$_" && !-r "$SET{'USER_DIR'}/$in{'id'}/BF.bfa" && !-r "$SET{'USER_DIR'}/BF.bfa") {
			$check{$_} = "NG";
			$check{'status'}{$_} = "Permission denied:<b>$_</b>";
		} else {
			if (-f "$SET{'USER_DIR'}/$in{'id'}/$_" && -r "$SET{'USER_DIR'}/$in{'id'}/$_") {
				$check{'status'}{$_} = "$SET{'USER_DIR'}/$in{'id'}/$_";
			} elsif (-f "$SET{'USER_DIR'}/$_" && -r "$SET{'USER_DIR'}/$_") {
				$check{'status'}{$_} = "$SET{'USER_DIR'}/$_";
			} elsif (&_open('line',"$SET{'USER_DIR'}/$in{'id'}/$_")) {
				$check{'status'}{$_} = "$SET{'USER_DIR'}/$in{'id'}/BF.bfa";
			} elsif (&_open('line',"$SET{'USER_DIR'}/$_")) {
				$check{'status'}{$_} = "$SET{'USER_DIR'}/BF.bfa";
			} else {
				$check{$_} = "NG";
				$check{'status'}{$_} = "Not found<b>$_</b>";
			}
		}
	}

	$check{'Code filter'} = "OK";
	if ($init{'code'}) {
		if ($SET{'NKF'}) {
			$check{'status'}{'Code filter'} = "$SET{'NKF'}";
		} elsif ($SET{'JCODE'}) {
			$check{'status'}{'Code filter'} = &_path($SET{'JCODE'});
		}
	} else {
		$check{'Code filter'} = "NG";
	}

	$tmp2 = 0;
	foreach (sort keys %check) {
		if ($_ eq 'status') { next; }
		$check{'status'}{$_} ||= "&nbsp;";
		if ($check{$_} eq 'NG') {
			$check{$_} = "<b style=\"color:#ff0000\">NG</b>";
			$tmp2 ++;
		}
		$print .= "<tr>	<th>$_</th>	<th>$check{$_}</th>	<td>$check{'status'}{$_}</td>	</tr>\n";
	}
	$print = "<b>$tmp2</b> of status are NG.\n<table border=1>$print</table>\n";


	if (-f "$SET{'USER_DIR'}/$in{'id'}/index") { &status; }

	undef @_;
}

# end of Bforum::check
1;
